package com.knecon.fforesight.service.layoutparser.processor.model.graph.nodes;

import java.awt.geom.Rectangle2D;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.knecon.fforesight.service.layoutparser.internal.api.data.redaction.LayoutEngine;
import com.knecon.fforesight.service.layoutparser.internal.api.data.redaction.NodeType;
import com.knecon.fforesight.service.layoutparser.processor.model.graph.DocumentTree;
import com.knecon.fforesight.service.layoutparser.processor.model.graph.entity.RedactionEntity;
import com.knecon.fforesight.service.layoutparser.processor.model.graph.textblock.TextBlock;
import com.knecon.fforesight.service.layoutparser.processor.model.graph.textblock.TextBlockCollector;

import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.FieldDefaults;

@Data
@Builder
@AllArgsConstructor
@FieldDefaults(level = AccessLevel.PRIVATE)
public class TableCell implements GenericSemanticNode {

    @Builder.Default
    Set<LayoutEngine> engines = new HashSet<>(Set.of(LayoutEngine.ALGORITHM));
    List<Integer> treeId;
    int row;
    int col;
    boolean header;

    Rectangle2D bBox;

    TextBlock leafTextBlock;

    TextBlock textBlock;

    @EqualsAndHashCode.Exclude
    DocumentTree documentTree;

    @Builder.Default
    @EqualsAndHashCode.Exclude
    Set<RedactionEntity> entities = new HashSet<>();


    @Override
    public Map<Page, Rectangle2D> getBBox() {

        Map<Page, Rectangle2D> bBoxPerPage = new HashMap<>();
        getPages().forEach(page -> bBoxPerPage.put(page, bBox));
        return bBoxPerPage;
    }


    @Override
    public NodeType getType() {

        return NodeType.TABLE_CELL;
    }


    @Override
    public boolean isLeaf() {

        return getDocumentTree().getEntryById(getTreeId()).getChildren().isEmpty();
    }


    @Override
    public TextBlock getTextBlock() {

        if (isLeaf()) {
            return leafTextBlock;
        }

        if (textBlock == null) {
            textBlock = buildTextBlock();
        }
        return textBlock;
    }


    private TextBlock buildTextBlock() {

        return streamAllSubNodes().filter(SemanticNode::isLeaf)
                .map(SemanticNode::getLeafTextBlock)
                .collect(new TextBlockCollector());
    }


    @Override
    public String toString() {

        return treeId + ": " + NodeType.TABLE_CELL + ": " + this.getTextBlock().buildSummary();
    }

}
